/*
 * (C) Copyright 2000-2005 Hewlett-Packard Development Company, L.P.
 */
#include "../CpqCiHlx.h"

//#ifdef loops_per_jiffy
//#undef loops_per_jiffy
//#endif

#if LINUX_VERSION_CODE < 0x020300
void CpqCiUSleep(unsigned long usecs)
{
	udelay(usecs);
}
#else
inline unsigned long long int time_stamp()
{
	unsigned long long int rc;
	__asm__ volatile ("rdtsc" : "=A" (rc));
	return rc;
}

void CpqCiUSleep(unsigned long usecs)
{
        unsigned long long end;
	end = time_stamp();
	end += (((unsigned long long)usecs * HZ) * current_cpu_data.loops_per_jiffy) >> 20; 

	while ( time_stamp() < end ) {
	       schedule();
	}
}
#endif
